"""
Simulation to create null distrubtion of Hox/ParaHox PAL orthologues in
Amphimedon queenslandica genome
Author: Olivia Mendivil Ramos (omr3@st-andrews.ac.uk)
"""
from operator import itemgetter
import random
import time 
import MySQLdb

"""Counter of cycles and final file with the output of the simulation"""
SimNo = 0
outfile = open('simulation_1000.csv','w')

"""Database connection"""
db = MySQLdb.connect(host="",user="",passwd="",db="amphiSimulation")
cursor = db.cursor()

while SimNo < 1000:

    SimNo += 1
    """File containing the contigs of Amphimedon queenslandica"""
    file = open("add.txt")
    """Dictionary comprising contig number and gene capacity value"""
    contigRef = {}
    """Dictionary comprising contig number and gene capacity value multiplied by proportion"""
    contigExp = {}
    
    for l in file:
        l1 = l.split(',')
        ls = int(l1[0].strip('Contig'))
        l2 = l1[1].strip('\n')
        l2 = int(l2)
        contigRef[ls] = l2
        
    print '----ContigRef'
    print contigRef
    
    """File containing """
    file2 = open("Nve_Aqu_HoxPal.txt")
    """Dictionary comprising contig number and """
    contigObs = {}
    
    for l in file2:
        l1 = l.split(',')
        l1a = int(l1[0])
        #print l1b
        l1b = l1[1].strip('\n')
        l2 = int(l1b)
        #print l2
        contigObs[l1a]=l2
        
    print'-----ContigObs'
    print contigObs
    
    for contig in contigRef:
        if contig not in contigObs:
            contigObs[contig] = 0
    print '-----ContigObs---with zeros'
    print contigObs

    ##hox = float(187)
    phoxpal = float(44)
    total = float(30060)
    proportion = hoxpal/total
    #proportion
    
    for contig in contigRef:
        n = contigRef[contig]
        x = n * proportion
        contigExp[contig] = x
    
    print '-----ContigExp'
    print contigExp
    
    contigWProb = {}
    for contig in contigRef:
        n = contigRef[contig]
        x = n/total
        contigWProb[contig] = x
        
    print '-----contigWProb'
    print contigWProb
        
    qgenes = 0
    for contig in contigRef:
        qgenes += contigRef[contig]
    print 'TOTAL AMOUNT OF GENES (30060):', qgenes
    #hoxPalList = []
    phoxPalList = []
    #hoxPalGenes = 187
    phoxPalGenes = 43
    index = 0 
    while index < qgenes:
        #hoxPalList.append(0)
        phoxPalList.append(0)
        index += 1
    print 'TOTAL LENGTH OF PHOXPALLIST:', len(phoxPalList)
    #print 'TOTAL LENGTH OF HOXPALLIST:',len(hoxPalList)
    indexA = 0
    while indexA < phoxPalGenes: #while indexA < hoxPalGenes:
    	#hoxPalList[random.randint(0, (qgenes-1))] = 1
    	phoxPalList[random.randint(0, (qgenes-1))] = 1
        indexA += 1
    

    qone = 0
    #for gene in hoxPalList:
    for gene in phoxPalList:
        if gene == 1:
            qone += 1
    print 'NUMBER OF ONES:', qone
    
  
    
    lx = 0
    x = 0
	"""Weighted choice based on the capacity of a scaffold"""
    contigSimulated = {}
    while x < 30060:
        n = random.uniform(0,1)
        print n
        for item, w in contigWProb.iteritems():
            if n < w:
                break
            n = n - w
        contigSimulated[x] = [item]
        contigSimulated[x].append(hoxPalList[lx])
        lx += 1
        x += 1
        
    print '----ContigSimulated'
    print contigSimulated
    
    
    #listHoxPalSim = []
    listPHoxPalSim = []
    trans = []
    unos = 0
    for cont, num in contigSimulated.iteritems():
        if num[1] == 1:
            unos += 1
            trans.append(num[0])
    trans.sort()
    counting = {}
    
    for i in set(trans):
        counting[i] = trans.count(i)
    
    for contig in contigRef:
        if contig not in counting:
            counting[contig] = 0
    print sorted(counting.items(), key=itemgetter(1))
    print "-----counting"
    print counting
    
    """Each cycle introduced to the relational databse and write the output of each simulation"""
    SimVsExp = 0
    deltaPos = 0
    deltaNeg = 0
    cero = 0
    for contig in counting:
        query = "INSERT INTO simulation (nsim, contig, value) VALUES ("+str(SimNo)+","+str(contig)+","+str(counting[contig])+")"
    #    print 'query-->',query
        cursor.execute(query)
        if contig in contigExp:
            if counting[contig] > contigExp[contig]:
                SimVsExp += 1
    
    print '--------Number of contigs that goes beyond the expected'
    outfile.write('--------Number of contigs that goes beyond the expected'+'\n')
    print SimVsExp
    outfile.write(str(SimNo)+','+str(SimVsExp)+'\n')

outfile.close()
delta.close()
cursor.close()
db.commit()
db.close()